#include "Board.h"
#include<iostream>
#define pii pair<int, int>
using namespace std;

Board::Board() {}

Board::Board(stringstream &stream){
	int x = 0, y = 0;
	b = vector<vector<bool> >(16, vector<bool>(16));
	string line;
	while (getline(stream, line, ',')){
		b[y][x] = (line == ".");
		if (line == "0"){
			playerPos[0] = make_pair(x,y);
		}
		if (line == "1")
			playerPos[1] = make_pair(x,y);
		x = (x+1)%16;
		if (x == 0)
			y++;
	}
}

vector<BoardMove> Board::LegalMoves(int pl){
	pair<int, int> pos = playerPos[pl];
	vector<BoardMove> moves;
	if (pos.second > 0	&& b[pos.second-1][pos.first]) moves.push_back(UP);
	if (pos.second < 15 && b[pos.second+1][pos.first]) moves.push_back(DOWN);
	if (pos.first > 0	 && b[pos.second][pos.first-1]) moves.push_back(LEFT);
	if (pos.first < 15	&& b[pos.second][pos.first+1]) moves.push_back(RIGHT);
	return moves;
}

pair<int, int> movePos(pair<int, int> o, BoardMove move)
{
	return make_pair(o.first + dX[move], o.second + dY[move]);
}

Board Board::Simulate(int id0, BoardMove move0, int id1, BoardMove move1)
{
	Board result = *this;
	result.playerPos[id0] = movePos(result.playerPos[id0], move0);
	result.b[result.playerPos[id0].second][result.playerPos[id0].first] = false;
	result.playerPos[id1] = movePos(result.playerPos[id1], move1);
	result.b[result.playerPos[id1].second][result.playerPos[id1].first] = false;
	return result;
}

void Board::Debug()
{
	for(int y=0; y<16; y++)
	{
		for(int x=0; x<16; x++)
		{
			if(b[y][x])cerr << ".";
			else if(pii(x, y) == playerPos[0]) cerr << "0";
			else if(pii(x, y) == playerPos[1]) cerr << "1";
			else cerr << "x";
		}
		cerr << endl;
	}
}
